#include <stdio.h>
#include <stdlib.h>

#define INIT_SIZE (32)
#define STEP_SIZE (2)

#define checkError(expr,userMsg) \
    do {\
        if (!(expr)) { \
            fprintf(stderr, "Greska: %s\n", userMsg);\
            exit(EXIT_FAILURE);\
        }\
    } while (0)

typedef struct {
    int* array;
    int size;
    int capacity;
} DynamicArray_t;

void allocateArray(DynamicArray_t* arr) {

    arr->capacity = INIT_SIZE;
    arr->size = 0;
    arr->array = malloc(INIT_SIZE*sizeof(int));

    checkError(arr->array != NULL, "malloc");
}

void add(DynamicArray_t* arr, int x) {

    if (arr->size == arr->capacity) {

        arr->capacity *= STEP_SIZE;
        arr->array = realloc(arr->array, arr->capacity*sizeof(int));

        checkError(arr->array != NULL, "realloc");

        printf("Realloc\n");
    }
    arr->array[arr->size++] = x;
}

void print(DynamicArray_t* arr) {

    int i = 0;
    for (i = 0; i <  arr->size; i++) {
        printf("%d ", arr->array[i]);
    }
    printf("\n");
}

void deleteArray(DynamicArray_t* arr) {

    free(arr->array);
}

int main(int argc, char** argv) {

    DynamicArray_t arr;

    allocateArray(&arr);

    for (int i = 0; i < 1000; i++) {

        add(&arr, i);
    }

    print(&arr);

    deleteArray(&arr);

    exit(EXIT_SUCCESS);
}
