#include <stdio.h>
#include <stdlib.h>

#define INIT_SIZE (32)
#define STEP_SIZE (2)

#define checkError(expr,userMsg) \
    do {\
        if (!(expr)) { \
            fprintf(stderr, "Greska: %s\n", userMsg);\
            fprintf(stderr, "File: %s\nFunction: %s\nLine: %d\n", \
                __FILE__, __func__, __LINE__);\
            exit(EXIT_FAILURE);\
        }\
    } while (0)

void kopirajFajl(char* src, char* dest) {

    FILE* in = fopen(src, "r");
    checkError(in != NULL, "fopen");

    FILE* out = fopen(dest, "w");
    checkError(out != NULL, "fopen");

    char c;
    while ((c = fgetc(in)) != EOF) {
        fputc(c, out);
    }

    fclose(in);
    fclose(out);
}

int prebrojReci(char* fName) {

    FILE* f = fopen(fName, "r");
    checkError(f != NULL, "fopen");

    int brojReci = 0;
    char buffer[256];
    while (fscanf(f, "%s", buffer) == 1) {

        brojReci++;
    }

    fclose(f);
    return brojReci;
}

int main(int argc, char** argv) {

    checkError(argc == 3, "args");

    kopirajFajl(argv[1], argv[2]);

    int r1 = prebrojReci(argv[1]);
    int r2 = prebrojReci(argv[2]);

    printf("%s\n", (r1 == r2 ? "isti su" : "nisu isti"));

    exit(EXIT_SUCCESS);
}
